package discoverer

import (
	"fmt"

	ocmd "git.loafle.net/overflow/commons-go/model/discovery"
	ocmm "git.loafle.net/overflow/commons-go/model/meta"
	"git.loafle.net/overflow/container_discovery/internal/discoverer/ipv4"
	"git.loafle.net/overflow/container_discovery/internal/discoverer/ipv6"
)

func scanService(port *ocmd.Port, ds *ocmd.DiscoverService, resultChan chan interface{}, errChan chan error, doneChan chan<- struct{}, stopChan chan struct{}) {
	defer func() {
		doneChan <- struct{}{}
	}()

	switch ocmm.ToMetaIPTypeEnum(port.Host.MetaIPType) {
	case ocmm.MetaIPTypeEnumV4:
		ipv4.ScanService(port, ds, resultChan, errChan, stopChan)
	case ocmm.MetaIPTypeEnumV6:
		ipv6.ScanService(port, ds, resultChan, errChan, stopChan)
	default:
		errChan <- fmt.Errorf("Discovery: Not supported MetaIPType")
	}

}
